/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define http_auth_enable 0
#define http_auth_local 1
#define http_auth_tacacs 2
#define http_auth_aaa 3


// HTTP
struct httpConfig
{
	int enabled;					// true, false
	int authentication;				// http_auth_enable...
	int accessClass;
};


// Process HTTP
void processHttp(char *line, struct ciscoIOSConfig *config, const int debugMode)
{
	// Debug
	if (debugMode == true)
	{
		printf("HTTP Line: %s\n", line);
	}

	// Create struct?
	if (config->http == 0)
	{
		config->http = malloc(sizeof(struct httpConfig));
		memset(config->http, 0, sizeof(struct httpConfig));
		config->http->enabled = true;
		config->http->authentication = http_auth_enable;	// default auth method
		config->http->accessClass = 0;
	}

	// HTTP server enabled
	if (strncmp(line, "ip http server", 14) == 0)
		config->http->enabled = true;

	// HTTP server disabled
	if (strncmp(line, "no ip http server", 17) == 0)
		config->http->enabled = false;

	// HTTP Access Class (Access List)
	if (strncmp(line, "ip http access-class", 20) == 0)
		config->http->accessClass = atoi(line + 21);

	// HTTP Authentication method
	if (strncmp(line, "ip http authentication", 22) == 0)
	{
		if (strncmp(line + 23, "aaa", 3) == 0)
			config->http->authentication = http_auth_aaa;

		else if (strncmp(line + 23, "local", 5) == 0)
			config->http->authentication = http_auth_local;

		else if (strncmp(line + 23, "tacacs", 6) == 0)
			config->http->authentication = http_auth_tacacs;

		else if (strncmp(line + 23, "enable", 6) == 0)
			config->http->authentication = http_auth_enable;
	}

	// HTTP Authentication method 2
	if (strncmp(line, "ip http auth", 12) == 0)
	{
		if (strncmp(line + 13, "aaa", 3) == 0)
			config->http->authentication = http_auth_aaa;

		else if (strncmp(line + 13, "local", 5) == 0)
			config->http->authentication = http_auth_local;

		else if (strncmp(line + 13, "tacacs", 6) == 0)
			config->http->authentication = http_auth_tacacs;

		else if (strncmp(line + 13, "enable", 6) == 0)
			config->http->authentication = http_auth_enable;
	}
}


