/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

int output_IOSTimeout(struct ciscoIOSConfig *config, int reportFormat, FILE *reportFile, int insecureTimeouts, int tableNum, char *friendlyHostname, const char *companyName)
{
	// Variables...
	struct lineConfig *linePointer;
	int tempInt;

	// Table Pointers
	const char *tablerow_start;
	const char *tablerow_mid;
	const char *tablerow_end;
	switch (reportFormat)
	{
		case output_html:
			tablerow_start = table_html_rowstart;
			tablerow_mid = table_html_rowmid;
			tablerow_end = table_html_rowend;
			break;
		case output_xml:
			tablerow_start = table_xml_rowstart;
			tablerow_mid = table_xml_rowmid;
			tablerow_end = table_xml_rowend;
			break;
		case output_text:
			tablerow_start = table_text_rowstart;
			tablerow_mid = table_text_rowmid;
			tablerow_end = table_text_rowend;
			break;
		case output_latex:
			tablerow_start = table_latex_rowstart;
			tablerow_mid = table_latex_rowmid;
			tablerow_end = table_latex_rowend;
			break;
	}

	output_parseTitle(report_timeout_title, reportFile, reportFormat, friendlyHostname, rate_med, section_security);
	output_parseText(report_timeout_obs1, reportFile, reportFormat, companyName, friendlyHostname, section_obs, rate_none, insecureTimeouts, tableNum);
	if ((connectionTimeout % 60) == 0)
	{
		numToWord(reportFile, (connectionTimeout / 60));
		fprintf(reportFile, " minutes");
	}
	else
	{
		numToWord(reportFile, connectionTimeout / 60);
		fprintf(reportFile, " minutes and ");
		numToWord(reportFile, connectionTimeout % 60);
		fprintf(reportFile, " seconds");
	}
	output_parseText(report_timeout_obs2, reportFile, reportFormat, companyName, friendlyHostname, section_none, rate_none, insecureTimeouts, tableNum);
	linePointer = config->line;
	if (insecureTimeouts > 1)
	{
		output_table(reportFile, reportFormat, true, false, report_timeout_table, &report_timeout_heading, tableNum, friendlyHostname);
		while (linePointer != 0)
		{
			if ((linePointer->lineLogin != false) && ((linePointer->timeout == 0) || (linePointer->timeout > connectionTimeout)) && ((linePointer->absoluteTimeout == 0) || (linePointer->absoluteTimeout > connectionTimeout)) && ((linePointer->sessionTimeout == 0) || (linePointer->sessionTimeout > connectionTimeout)) && ((linePointer->execTimeout == 0) || (linePointer->execTimeout > connectionTimeout)))
			{
				switch (linePointer->lineType)
				{
					case line_console:
						fprintf(reportFile, "%sConsole Line", tablerow_start);
						break;
					case line_vty:
						fprintf(reportFile, "%sVTY Line", tablerow_start);
						break;
					case line_tty:
						fprintf(reportFile, "%sTTY Line", tablerow_start);
						break;
					case line_aux:
						fprintf(reportFile, "%sAuxiliary Line", tablerow_start);
						break;
				}
				if (linePointer->lineNumberEnd == 0)
					fprintf(reportFile, " %d%s", linePointer->lineNumberStart, tablerow_mid);
				else
					fprintf(reportFile, "s %d to %d%s", linePointer->lineNumberStart, linePointer->lineNumberEnd, tablerow_mid);
				if ((linePointer->timeout == 0) && (linePointer->sessionTimeout == 0) && (linePointer->absoluteTimeout == 0) && (linePointer->execTimeout == 0))
					fprintf(reportFile, "No Timeout%s", tablerow_end);
				else
				{
					tempInt = 0;
					if (linePointer->timeout != 0)
					{
						if ((linePointer->timeout % 60) == 0)
							fprintf(reportFile, "Timeout: %d minutes", (linePointer->timeout / 60));
						else
							fprintf(reportFile, "Timeout: %d minutes and %d seconds", linePointer->timeout / 60, linePointer->timeout % 60);
						tempInt++;
					}
					if (linePointer->absoluteTimeout != 0)
					{
						if (tempInt > 0)
							fprintf(reportFile, ", ");
						if ((linePointer->absoluteTimeout % 60) == 0)
							fprintf(reportFile, "Absolute Timeout: %d minutes", (linePointer->absoluteTimeout / 60));
						else
							fprintf(reportFile, "Absolute Timeout: %d minutes and %d seconds", linePointer->absoluteTimeout / 60, linePointer->absoluteTimeout % 60);
						tempInt++;
					}
					if (linePointer->sessionTimeout != 0)
					{
						if (tempInt > 0)
							fprintf(reportFile, ", ");
						if ((linePointer->sessionTimeout % 60) == 0)
							fprintf(reportFile, "Session Timeout: %d minutes", (linePointer->sessionTimeout / 60));
						else
							fprintf(reportFile, "Session Timeout: %d minutes and %d seconds", linePointer->sessionTimeout / 60, linePointer->sessionTimeout % 60);
						tempInt++;
					}
					if (linePointer->execTimeout != 0)
					{
						if (tempInt > 0)
							fprintf(reportFile, ", ");
						if ((linePointer->execTimeout % 60) == 0)
							fprintf(reportFile, "Exec Timeout: %d minutes", (linePointer->execTimeout / 60));
						else
							fprintf(reportFile, "Exec Timeout: %d minutes and %d seconds", linePointer->execTimeout / 60, linePointer->execTimeout % 60);
						tempInt++;
					}
					fprintf(reportFile, "%s", tablerow_end);
				}
			}
			linePointer = linePointer->next;
		}
		output_table(reportFile, reportFormat, false, false, report_timeout_table, &report_timeout_heading, tableNum, friendlyHostname);
		tableNum++;
	}
	else
	{
		while (linePointer != 0)
		{
			if ((linePointer->lineLogin != false) && ((linePointer->timeout == 0) || (linePointer->timeout > connectionTimeout)) && ((linePointer->absoluteTimeout == 0) || (linePointer->absoluteTimeout > connectionTimeout)) && ((linePointer->sessionTimeout == 0) || (linePointer->sessionTimeout > connectionTimeout)) && ((linePointer->execTimeout == 0) || (linePointer->execTimeout > connectionTimeout)))
			{
				switch (linePointer->lineType)
				{
					case line_console:
						fprintf(reportFile, "Console Line");
						break;
					case line_vty:
						fprintf(reportFile, "VTY Line");
						break;
					case line_tty:
						fprintf(reportFile, "TTY Line");
						break;
					case line_aux:
						fprintf(reportFile, "Auxiliary Line");
						break;
				}
				if (linePointer->lineNumberEnd == 0)
					fprintf(reportFile, " %d", linePointer->lineNumberStart);
				else
					fprintf(reportFile, "s %d to %d", linePointer->lineNumberStart, linePointer->lineNumberEnd);
				if ((linePointer->timeout == 0) && (linePointer->sessionTimeout == 0) && (linePointer->absoluteTimeout == 0) && (linePointer->execTimeout == 0))
					fprintf(reportFile, " had no timeout.");
				else
				{
					fprintf(reportFile, " ");
					tempInt = 0;
					if (linePointer->timeout != 0)
					{
						if ((linePointer->timeout % 60) == 0)
							fprintf(reportFile, "Timeout: %d minutes", (linePointer->timeout / 60));
						else
							fprintf(reportFile, "Timeout: %d minutes and %d seconds", linePointer->timeout / 60, linePointer->timeout % 60);
						tempInt++;
					}
					if (linePointer->absoluteTimeout != 0)
					{
						if (tempInt > 0)
							fprintf(reportFile, ", ");
						if ((linePointer->absoluteTimeout % 60) == 0)
							fprintf(reportFile, "Absolute Timeout: %d minutes", (linePointer->absoluteTimeout / 60));
						else
							fprintf(reportFile, "Absolute Timeout: %d minutes and %d seconds", linePointer->absoluteTimeout / 60, linePointer->absoluteTimeout % 60);
						tempInt++;
					}
					if (linePointer->sessionTimeout != 0)
					{
						if (tempInt > 0)
							fprintf(reportFile, ", ");
						if ((linePointer->sessionTimeout % 60) == 0)
							fprintf(reportFile, "Session Timeout: %d minutes", (linePointer->sessionTimeout / 60));
						else
							fprintf(reportFile, "Session Timeout: %d minutes and %d seconds", linePointer->sessionTimeout / 60, linePointer->sessionTimeout % 60);
						tempInt++;
					}
					if (linePointer->execTimeout != 0)
					{
						if (tempInt > 0)
							fprintf(reportFile, ", ");
						if ((linePointer->execTimeout % 60) == 0)
							fprintf(reportFile, "Exec Timeout: %d minutes", (linePointer->execTimeout / 60));
						else
							fprintf(reportFile, "Exec Timeout: %d minutes and %d seconds", linePointer->execTimeout / 60, linePointer->execTimeout % 60);
						tempInt++;
					}
					output_newPara(reportFile, reportFormat);
				}
			}
			linePointer = linePointer->next;
		}
	}
	output_endsection(reportFile, reportFormat, section_obs);
	output_parseText(report_timeout_impact, reportFile, reportFormat, companyName, friendlyHostname, section_imp, rate_high, 0, 0);
	output_endsection(reportFile, reportFormat, section_imp);
	output_parseText(report_timeout_ease, reportFile, reportFormat, companyName, friendlyHostname, section_ease, rate_difficult, 0, 0);
	output_endsection(reportFile, reportFormat, section_ease);
	output_parseText(report_timeout_rec1, reportFile, reportFormat, companyName, friendlyHostname, section_rec, rate_none, 0, 0);
	if ((connectionTimeout % 60) == 0)
	{
		numToWord(reportFile, (connectionTimeout / 60));
		fprintf(reportFile, " minutes");
	}
	else
	{
		numToWord(reportFile, connectionTimeout / 60);
		fprintf(reportFile, " minutes and ");
		numToWord(reportFile, (connectionTimeout % 60));
		fprintf(reportFile, " seconds");
	}
	output_parseText(report_timeout_rec2, reportFile, reportFormat, companyName, friendlyHostname, section_none, rate_none, 0, 0);
	output_endsection(reportFile, reportFormat, section_rec);

	// Return tableNum
	return tableNum;
}

