/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// CDP
void processNMPCDP(char *line, struct ciscoNMPConfig *configNMP, const int debugMode)
{
	// Variables
	int offset;
	int offsetStart;
	int range;
	int module;
	int port;
	int tempInt;
	struct portConfig *portNMPPointer;
	struct ciscoCommand command;

	// Debug output
	if (debugMode == true)
		printf("CDP Line: %s\n", line);

	// Init
	offset = 0;
	command = splitLine(line);


	// Global Enable / Disable
	if (((strcmp(command.part[2], "enable") == 0) || (strcmp(command.part[2], "disable") == 0)) && (command.parts == 3))
	{
		if (strcmp(command.part[2], "enable") == 0)
			configNMP->cdp = true;
		else
			configNMP->cdp = false;
	}

	// Interval
	else if (strcmp(command.part[2], "interval") == 0)
		configNMP->cdpInterval = atoi(command.part[3]);

	// Holdtime
	else if (strcmp(command.part[2], "holdtime") == 0)
		configNMP->cdpHoldtime = atoi(command.part[3]);

	// Version
	else if (strcmp(command.part[2], "version") == 0)
	{
		if (strcmp(command.part[3], "v1") == 0)
			configNMP->cdpVersion = 1;
		else
			configNMP->cdpVersion = 2;
	}

	// Individual Port Enable / Disable
	else if (((strcmp(command.part[2], "enable") == 0) || (strcmp(command.part[2], "disable") == 0)) && (command.parts == 4))
	{
		if (strcmp(command.part[2], "enable") == 0)
			tempInt = true;
		else
			tempInt = false;

		while (command.part[3][offset] != 0)
		{
			// Get Module number
			offsetStart = offset;
			while ((command.part[3][offset] != 0) && (command.part[3][offset] != '/'))
				offset++;
			command.part[3][offset] = 0;
			module = atoi(command.part[3] + offsetStart);
			offset++;

			// Get Port number
			offsetStart = offset;
			while ((command.part[3][offset] != 0) && (command.part[3][offset] != '-') && (command.part[3][offset] != ','))
				offset++;
			if (command.part[3][offset] == '-')
				range = true;
			else
				range = false;
			command.part[3][offset] = 0;
			port = atoi(command.part[3] + offsetStart);

			// Create Port
			portNMPPointer = createNMPPort(module, port, configNMP);

			// Set CDP
			portNMPPointer->cdp = tempInt;

			// If it is a range
			if (range == true)
			{
				// Set End Port
				offset++;
				offsetStart = offset;
				while ((command.part[3][offset] != 0) && (command.part[3][offset] != ','))
					offset++;
				command.part[3][offset] = 0;

				// Add each port in range
				while (port < atoi(command.part[3] + offsetStart))
				{
					port++;
					portNMPPointer = createNMPPort(module, port, configNMP);

					// Set CDP
					portNMPPointer->cdp = tempInt;
				}
			}

			// Move offset
			offset++;
		}
	}
}
